#ifndef CarH
#define CarH

#include <Classes.hpp>
#include "MyThread.h"
class MyThread;

/*
 * Protocol
 */
enum Command { 
  // Lights
    LOnL, LOffL, // Turn on/off Line Change Left
    LOnR, LOffR, // Turn on/off Line Change Right
    LOnW, LOffW, // Turn on/off Warning Lights
  // State
    SAOn, SAOff, // Automatically send the state on/off
    SG,          // Give the state
  // Acceleration
    ASV,         // Set the acceleration value
    AIV,         // Increase acceleration value
    ADV          // Decrease acceleration value
};

class Car {
public:
        HANDLE m_hCommPort;
        Car(const char* comPort);
        ~Car();
        void blinkLeft(bool on);
        void blinkRight(bool on);
        void blinkWarn(bool on);
        void accelerationSet(unsigned char value);
        void accelerationIncrease(unsigned char value);
        void accelerationDecrease(unsigned char value);
        void sendStateNow();
        void sendStateAutomatic(bool on);
        static char* getResponseText(Command response);
private:
        MyThread *threadReception;
        unsigned char packet[8]; /*packet buffer*/
        void initPacket();
        void sendPacket();
        void singleCommandPacket(Command command);
        unsigned char calculateChecksum(const unsigned char* packet,
                const unsigned char length);
};
#endif
