//---------------------------------------------------------------------------
#include "main.h"

#include <vcl.h>
#pragma hdrstop

#include "Car.h"
#include "MyThread.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFMain *FMain;

extern unsigned char rdbuff[];
extern int rdindex;
extern int errors;

unsigned char rtbuff[1000];
int rtindex=0;

Car *car = 0;


//---------------------------------------------------------------------------
__fastcall TFMain::TFMain(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnOpenCOMClick(TObject *Sender)
{
        try {
                car = new Car(cbSelectCOM->Text.c_str());
        } catch (int e) {
                switch(e) {
                case 1:
                        ShowMessage("can not open port");
                        break;
                case 2:
                        ShowMessage("invalid handle value");
                        break;
                case 3:
                        ShowMessage("error getting serial port state");
                        break;
                case 4:
                        ShowMessage(" error setting serial port state");
                        break;
                }
                return;
        }

        lHCom->Caption = (int)car->m_hCommPort;

        btnOpenCOM->Enabled = false;
        btnCloseCOM->Enabled = true;
        eValueA->SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnShowErrClick(TObject *Sender)
{
        lErrors->Caption = errors;
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnCloseCOMClick(TObject *Sender)
{
        delete car;
        car = 0;
        lHCom->Caption = "closed";
        btnOpenCOM->Enabled = true;
        btnCloseCOM->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnBlinkLeftClick(TObject *Sender) {
        if(car) car->blinkLeft(true);
}

void __fastcall TFMain::btnBlinkRightClick(TObject *Sender) {
        if(car) car->blinkRight(true);
}

void __fastcall TFMain::btnBlinkLeftOffClick(TObject *Sender) {
        if(car) car->blinkLeft(false);
}

void __fastcall TFMain::cmdBlinkWarnOffClick(TObject *Sender) {
        if(car) car->blinkWarn(false);
}

void __fastcall TFMain::cmdBlinkWarnClick(TObject *Sender) {
        if(car) car->blinkWarn(true);
}

void __fastcall TFMain::cmdBlinkRightOffClick(TObject *Sender) {
        if(car) car->blinkRight(false);
}

void __fastcall TFMain::btnAccSetClick(TObject *Sender)
{
        if(car) car->accelerationSet((StrToInt(eAccSet->Text)));
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnAccIncreaseClick(TObject *Sender)
{
        if(car) car->accelerationIncrease((StrToInt(eAccIncrease->Text)));
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnAccDecreaseClick(TObject *Sender)
{
        if(car) car->accelerationDecrease((StrToInt(eAccDecrease->Text)));
}
//---------------------------------------------------------------------------


void __fastcall TFMain::btnSendStateAutoClick(TObject *Sender)
{
        if(car) car->sendStateAutomatic(true);
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnSendStateStopAutoClick(TObject *Sender)
{
        if(car) car->sendStateAutomatic(false);
}
//---------------------------------------------------------------------------

void __fastcall TFMain::btnSendStateNowClick(TObject *Sender)
{
        if(car) car->sendStateNow();
}
//---------------------------------------------------------------------------

